<template>
  <div class="group-modal">
    <div class="flex justify-between">
      <div class="text-xl font-semibold">
        {{ mode === "add" ? "สร้างกลุ่ม" : "แก้ไขกลุ่ม" }}
      </div>

      <img
        :src="require('~/assets/images/Close.svg')"
        alt="Close.svg"
        class="cursor-pointer w-6"
        @click="closeModal"
      />
    </div>

    <div class="border-primary border p-8 rounded-md mt-4">
      <div class="grid grid-cols-2 grid-rows-1 gap-[100px]">
        <div>
          <div>ชื่อกลุ่ม</div>

          <input
            v-model="form.name"
            type="text"
            class="px-3 py-1 rounded-md w-full mt-2 focus:outline-none text-black"
          />

          <div class="mt-4">แสดงข้อมูลที่เลือก</div>

          <div
            class="bg-white px-3 py-2 rounded-md w-full mt-2 flex flex-wrap gap-2 h-[150px] overflow-y-auto"
          >
            <span
              v-for="(item, index) in form.active_list"
              :key="index"
              style="height: fit-content"
              class="bg-lightblue rounded-md px-3 py-1 text-black flex items-center gap-2"
            >
              {{ item }}

              <img
                :src="require('~/assets/images/Close copy.svg')"
                alt="Close copy.svg"
                class="cursor-pointer w-3"
                @click="removeLight(index, item)"
              />
            </span>
          </div>

          <div class="mt-20">ระดับความสว่าง</div>

          <img
            :src="require('~/assets/images/Group 722.svg')"
            alt="Group 722.svg"
            class="mx-auto w-10 mt-10"
          />

          <div class="flex items-center justify-center font-semibold">
            <el-slider v-model="form.light_step" class="w-3/5 mr-4"></el-slider>

            {{ form.light_step }}%
          </div>
        </div>

        <div>
          <div class="flex gap-4">
            เลือกข้อมูล

            <div class="flex-1 border-b border-grey flex items-center">
              <input
                type="text"
                v-model="search"
                style="background: none"
                class="flex-1 px-3 focus:outline-none"
              />

              <img
                :src="require('~/assets/images/Search.svg')"
                alt="Search.svg"
              />
            </div>
          </div>

          <div
            class="bg-white px-3 py-2 rounded-md w-full mt-2 h-[228px] overflow-y-auto"
          >
            <div class="border-b border-grey">
              <div
                v-for="(option, index) in filter_light_options"
                :key="index"
                class="flex items-center text-black p-2 border border-grey border-b-0"
              >
                <img
                  :src="require('~/assets/images/street-light (1) 1.svg')"
                  alt="street-light (1) 1.svg"
                  class="mr-3 w-4"
                />

                <span class="flex-1">
                  {{ option.name }}
                </span>

                <el-checkbox
                  v-model="option.is_active"
                  @change="checkLight"
                ></el-checkbox>
              </div>
            </div>
          </div>

          <div class="mt-20">ตั้งเวลา เปิด - ปิดไฟ</div>

          <div
            class="border-b border-blue text-blue flex items-center gap-4 text-center mt-4"
          >
            <div class="flex-1">เวลาเปิดไฟ</div>

            <span class="opacity-0">-</span>

            <div class="flex-1">เวลาปิดไฟ</div>

            <img
              v-if="form.time_list.length > 1"
              :src="require('~/assets/images/Delete.svg')"
              alt="Delete.svg"
              class="opacity-0"
            />
          </div>

          <div
            v-for="(time, index) in form.time_list"
            :key="index"
            class="flex items-center gap-4 mt-4"
          >
            <input
              type="time"
              class="flex-1 px-3 py-1 text-black rounded-md mt-1 focus:outline-none"
              v-model="time.open"
            />

            -

            <input
              type="time"
              class="flex-1 px-3 py-1 text-black rounded-md mt-1 focus:outline-none"
              v-model="time.close"
            />

            <img
              v-if="form.time_list.length > 1"
              :src="require('~/assets/images/Delete.svg')"
              alt="Delete.svg"
              class="cursor-pointer"
              @click="removeTime(index)"
            />
          </div>

          <button
            class="border-primary border text-primary px-8 py-1 rounded-md mt-4"
            @click="addTime"
          >
            เพิ่มเวลา
          </button>
        </div>
      </div>
    </div>

    <button
      class="bg-primary text-white px-10 py-2 text-xl rounded-md block mt-4 mx-auto"
      @click="saveForm(form)"
    >
      {{ mode === "add" ? "สร้าง" : "บันทึก" }}
    </button>
  </div>
</template>

<script>
import Vue from "vue";
import _ from "lodash";
import { Slider, Checkbox } from "element-ui";
Vue.use(Slider);
Vue.use(Checkbox);

export default {
  props: {
    mode: {
      type: String,
      default: "add",
    },
    closeModal: {
      type: Function,
      default: () => {
        return {};
      },
    },
    edit_group: {
      type: Object,
      default: () => {
        return {};
      },
    },
    addGroup: {
      type: Function,
      default: () => {
        return {};
      },
    },
    editGroup: {
      type: Function,
      default: () => {
        return {};
      },
    },
    light_data: {
      type: Array,
      default: () => {
        return [];
      },
    },
  },
  data() {
    return {
      form: {
        name: "",
        status: false,
        light_step: 0,
        active_list: [],
        time_list: [
          {
            open: "",
            close: "",
          },
        ],
      },
      search: "",
      light_options: [],
    };
  },
  computed: {
    filter_light_options() {
      return _.filter(this.light_options, (o) => o.name.includes(this.search));
    },
  },
  created() {
    if (this.mode === "edit") this.setForm();

    this.light_options = _.map(this.light_data, (d) => {
      return { ...d, is_active: this.form.active_list.includes(d.name) };
    });
  },
  methods: {
    checkLight() {
      const options = _.filter(this.light_options, (o) => o.is_active);
      this.form.active_list = _.map(options, (o) => o.name);
    },
    removeLight(index, item) {
      this.form.active_list.splice(index, 1);

      const active_index = _.findIndex(
        this.light_options,
        (o) => o.name === item
      );

      this.light_options[active_index].is_active = false;
    },
    removeTime(index) {
      this.form.time_list.splice(index, 1);
    },
    addTime() {
      this.form.time_list.push({
        open: "",
        close: "",
      });
    },
    setForm() {
      this.form = _.cloneDeep({ ...this.form, ...this.edit_group });
    },
    saveForm(form) {
      if (this.mode === "add") this.addGroup(form);
      if (this.mode === "edit") this.editGroup(form);
      this.closeModal();
    },
  },
};
</script>

<style lang="scss" scoped></style>
